﻿@page "/bicycles"
@using Veloverleih.Shared.Models
@using Veloverleih.Shared
@using System.Linq.Expressions
@using System.Data.Services.Client
@using Microsoft.CodeAnalysis.FlowAnalysis.DataFlow
@inject HttpClient Http
@inject NavigationManager NavigationManager



<PageTitle>Bicycles</PageTitle>

<h1>Bicycles</h1>

@if (bicycles == null)
{
    <div class="spinner-border text-primary" role="status">
        <span class="visually-hidden">Loading...</span>
    </div>
}
else
{

    <nav class="navbar navbar-expand-lg bg-body-tertiary">
                <EditForm class="d-flex" role="search" Model="@filter">
                    <InputDate class="form-control" @bind-Value="filter.StartTime" />
                    <InputDate class="form-control" @bind-Value="filter.EndTime" />
                    <InputText placeholder="Name "@bind-Value="filter.Name" />
                    <InputText placeholder="Marke" @bind-Value="filter.Marke" />
                </EditForm>
                <button class="btn btn-outline-success" @onclick="SearchButtonClicked" type="submit">Search</button>
                <button class="btn btn-outline-success" @onclick="ResethButtonClicked" type="reset">Clear</button>
    </nav>

<div class="row row-cols-1 row-cols-sm-2 row-cols-md-3 g-3">
    @foreach (BicycleModel bicycle in bicycles)
    {
        <BicycleCard Bicycle="bicycle" />
    }
</div>    
}

@code {
    private BicycleModel[]? bicycles;
    private BicycleFilter filter = new BicycleFilter();
    

    protected override async Task OnInitializedAsync()
    {
        await LoadUnfilteredData();
    }

    private async Task LoadUnfilteredData()
    {
        bicycles = await Http.GetFromJsonAsync<BicycleModel[]>("api/Bicycle");
    }

    private async Task SearchButtonClicked()
    {
        var dsContext = new DataServiceContext(new Uri("http://test"));
        // Base query
        IQueryable<BicycleModel> query;

        if (filter.DateRangeIsSet)
        {
            // TODO: Implement booking so we can search for if bike is available.
        }
        if (filter.Name != "" && filter.Name is not null && filter.Marke != "" && filter.Marke is not null)
        {
            query = dsContext.CreateQuery<BicycleModel>("/api/Bicycle").Where(b => b.Name == filter.Name).Where(b => b.Marke == filter.Marke);
        }
        else if (filter.Marke != "" && filter.Marke is not null)
        {
            query = dsContext.CreateQuery<BicycleModel>("/api/Bicycle").Where(b => b.Marke == filter.Marke);
        }
        else if (filter.Name != "" && filter.Name is not null)
        {
            query = dsContext.CreateQuery<BicycleModel>("/api/Bicycle").Where(b => b.Name == filter.Name);
        }
        else
        {
            query = dsContext.CreateQuery<BicycleModel>("/api/Bicycle");
        }

        var uri = new Uri(query.ToString());
        bicycles = await Http.GetFromJsonAsync<BicycleModel[]>($"api/Bicycle{uri.Query}");
        StateHasChanged();
    }

    private async Task ResethButtonClicked()
    {
        filter = new BicycleFilter();
        await LoadUnfilteredData();
    }


}
